/*---------------------------------------------------------------------------
 *
 *      Title:          Farsi Text Editor - Main module
 *
 *      File:           farsi.c
 *
 *      Date:           May 1995
 *
 *      Description:
 *          This module provides the basics for the text editor.
 *
 *      Rev     By              Description                            Date
 *      1.0     R.J.Harrison    Implement                              2-5-95
 *
 *      Copyright  1995 Zaretto Ltd.
 *---------------------------------------------------------------------------*/


#include <exec/types.h>
#include <libraries/dos.h>
#include <workbench/workbench.h>
#include <workbench/startup.h>
#include <proto/icon.h>
#ifdef LATTICE
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#endif

#include <stdio.h>
#include <unix/getargs.h>

#include "zpl.h"

char *resource_database="resources";
char *preference_database="farsi.preferences";
char re_database_version='0';

TY_int main (TY_int argc, char **argv)
{
    /*
     * Initialise the farsi text engine
     */
    farsi_init ();

    /*
     * Initialise the machine dependant module
     */
    init_machine (argc, argv);

    /*
     * Init_window, this will open the screen, and all required libraries.
     */
    if (init_window ())
    {
	init_prefs ();	/* Load preferences */

        init_keyboard(); /* Load farsi keyboard */
	UI_edit(0,0);

        while (1)
	    wait_for_event ();
    }
    close_system ();
    return (0);
}

char *get_screen_title(void)
{
    return "Farsi Text Editor %s, 1995 ";
}

int get_last_group(void)
{
    return GR_LAST;
}

char *get_public_screen_name(void)
{
    return "FARSI";
}

char *get_debug_filename (void)
{
    return "t:farsi_edit.dbg";
}
