/*----------------------------------------------------------------------
 *
 *      Title:          CDL header
 *
 *      Description:
 *              This file defines the structures and constants used within
 *      the command definition language.
 *
 *      Author:   Richard J. Harrison
 *      Date  :   30 November 1989
 *
 *      Rev    : 1.1
 *      1.1 R.J.Harrison        NICOLA release version          1 Mar 1991
 *----------------------------------------------------------------------*/


#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define COMLEN 		40	/*
				 * Maximum command length 
				 */
#define PARAMLEN 	40	/*
				 * Maximum parameter length 
				 */
#define MAXPARAM 	25	/*
				 * Maximum number of parameters 
				 */
#define ABBREVIATE_ALL_PARAMETERS 	FALSE

#define PARAM_POSITIONAL (1<<0)
#define PARAM_REQUIRED   (1<<1)
#define PARAM_PRESENT    (1<<2)
#define PARAM_VALUE_REQUIRED   (1<<3)

typedef enum PARAM_TYPE
{
    INTEGER, TBOOLEAN, SBOOLEAN,
    FBOOLEAN, CHARACTER, STRING
} PARAM_TYPE;

typedef struct PARAM
{
    char parameter[PARAMLEN];
    char min_abb_p[PARAMLEN];
    PARAM_TYPE type;
    TY_int flags;
    TY_int *variable;
}
PARAM;

typedef struct TOK
{
    char command[COMLEN];
    char min_abb[COMLEN];
    void (*func) (struct TOK *, TY_int);
    PARAM *parameters[MAXPARAM];
    TY_int number_of_parameters;
    TY_int flags;
}

TOK;

typedef struct
{
    TOK *table;
    TY_int num_commands, max_commands;
}

TOK_ROOT;


#ifndef IGNORE_PROTOS
#include "cdl.p"
#endif
extern TOK *add_command ();
