#ifndef ALLOC_PROTOS_ONLY
#define SAVESTR_CHECK

#ifdef calloc
#undef calloc
#endif
#ifdef free
#undef free
#endif
#ifdef malloc
#undef malloc
#endif
#ifdef savestr
#undef savestr
#endif

#ifndef MODULE
#define MODULE __FILE__
#endif

#define calloc(a,b) MY_calloc(a,b,MODULE,__LINE__)
#define malloc(a) MY_malloc(a,MODULE,__LINE__)
#define free(a) MY_free(a,MODULE,__LINE__)
#define savestr(a) MY_savestr(a,MODULE,__LINE__)

#define FW_calloc(a,b,c) _FW_calloc(a,b,c,MODULE,__LINE__)
#define FW_malloc(a,b) _FW_malloc(a,b,MODULE,__LINE__)
#define FW_free(a,b) _FW_free(a,b,MODULE,__LINE__)
#define FW_savestr(a,b) _FW_savestr(a,b,MODULE,__LINE__)
#endif

/*
 * Prototypes for functions defined in alloc_check.c 
 */
void MY_ov_check_memory (void);
TY_int MY_get_dynamic_memory_usage (void);
void MY_scan_check_memory (void);
void MY_dump_memory (void);
void MY_check_memory_freed (void);
void *MY_calloc (unsigned TY_int ne,
		 unsigned TY_int sz,
		 char *module,
		 TY_int line);
void *MY_malloc (unsigned TY_int sz,
		 char *module,
		 TY_int line);
void MY_free (void *a,
	      char *module,
	      TY_int line);
void *MY_savestr (char *p, char *module, TY_int line);

void *_FW_calloc (void * fw,
		  unsigned TY_int ne,
		  unsigned TY_int sz,
		  char *module,
		  TY_int line);
void *_FW_malloc (void * fw,
		  unsigned TY_int sz,
		  char *module,
		  TY_int line);
void _FW_free (void * fw,
	       void *a,
	       char *module,
	       TY_int line);
void FW_free_all (void * fw);
void *_FW_savestr (void * fw,
		   char *p,
		   char *module,
		   TY_int line);
