#define DAYS_TO_SECONDS(n)  ((n)*(long)(60 * 60 * 24))

/*#include "ztdio.h"*/
#define calloc  ZZZ_calloc
#define free  ZZZ_free
#define malloc  ZZZ_malloc
#define savestr  ZZZ_savestr

#ifndef max
#define   max(a,b)    ((a) > (b) ? (a) : (b))
#endif
#ifndef min
#define   min(a,b)    ((a) <= (b) ? (a) : (b))
#endif

struct MY_stat
{
    short st_dev;
    short st_ino;
    short st_mode;
    short st_nlink;
    int st_uid;
    int st_gid;
    short st_rdev;
    long st_size;
    long st_atime;
    long st_mtime;
    long st_ctime;
};

typedef struct
{
char shift_alt, alt, shift, plain;
}CH_KEY_MAP;

struct	 MY_KeyMap { /* It's the amiga one... */
    unsigned char *km_LoKeyMapTypes;
    CH_KEY_MAP    *km_LoKeyMap;
    unsigned char *km_LoCapsable;
    unsigned char *km_LoRepeatable;
    unsigned char *km_HiKeyMapTypes;
    CH_KEY_MAP    *km_HiKeyMap;
    unsigned char *km_HiCapsable;
    unsigned char *km_HiRepeatable;
};


#ifdef WINDOWS
#define SWAP_LONG(v) (((v & 0xff000000) >> 24) | ((v & 0xff0000) >> 8) | ((v &  0xff00) << 8) | ((v & 0xff) << 24))

#ifndef WIN32
#define PLACE far
#else
#define PLACE
#endif

#define TY_int long
#define TY_unsigned unsigned long
#define STATIC_VAR(v,t,sz) static int _sz=sz; static t *__t=NULL; t * v = __t ? __t : (__t=calloc(sz,sizeof(t)))
#define STATIC_NA_VAR(v,t) static t *__t=NULL; t * v = __t ? __t : (__t=calloc(1,sizeof(t)))
#define SV_SIZEOF(v) _sz

#ifdef USE_FAR_MEMCPY
#define memccpy _fmemccpy
#define memcmp _fmemcmp
#define memcpy _fmemcpy
#define memicmp _fmemicmp
#define memmove _fmemmove
#define memset _fmemset
#endif

#ifndef WIN32
#define printf error_log
#endif
#define __OS_DONE
#else
#define HFONT int
#define HWND int
#endif /* WINDOWS */

#ifdef AMIGA
#define __OS_DONE
#include <time.h>
#include <exec/types.h>
#include <proto/dos.h>

#define TY_int int
#define TY_unsigned unsigned
#define STATIC_VAR(v,t,sz) static t v [ sz ]
#define STATIC_NA_VAR(v,t) static t *__t=NULL; t * v = __t ? __t : (__t=calloc(1,sizeof(t)))
#define SV_SIZEOF(v) sizeof(v)
#define NO_FTRANSLATE
#define SWAP_LONG(v) (v)
#endif /* AMIGA */

#ifdef VMS
#define MOTIF
#define TY_int int
#define TY_unsigned unsigned
#define __OS_DONE
#define STATIC_VAR(v,t,sz) static t v [ sz ]
#define STATIC_NA_VAR(v,t) static t *__t=NULL; t * v = __t ? __t : (__t=calloc(1,sizeof(t)))
#define SV_SIZEOF(v) sizeof(v)
#endif /* OS_DONE */

#ifndef __OS_DONE
#define SWAP_LONG(v) (v)
#define TY_int int
#define TY_unsigned unsigned
#define __OS_DONE
#define STATIC_VAR(v,t,sz) static t v [ sz ]
#define STATIC_NA_VAR(v,t) static t *__t=NULL; t * v = __t ? __t : (__t=calloc(1,sizeof(t)))
#define SV_SIZEOF(v) sizeof(v)
#define MF_ENABLED 1
#define HMENU int
#define HWND int
#define MF_GRAYED 2
#define MF_POPUP 3
#define MF_DISABLED 4
#define MF_SEPARATOR 5
#define MF_STRING 6
#define UINT int
#define LPARAM int
#define LB_RESETCONTENT 1
#define LB_SETCURSEL  1
#define LB_ADDSTRING 2
#define WS_CHILD 1
#define SBS_HORZ 1
#define SBS_VERT  1
#define BS_AUTOCHECKBOX 1
#define WS_VSCROLL 1
#define WS_BORDER 1
#define WS_CHILD 1
#define LBS_NOTIFY 1
#define LBS_DISABLENOSCROLL 1
#define CB_ADDSTRING 1
#define CBS_DROPDOWNLIST 1
#define ES_AUTOHSCROLL 1
#endif /* OS_DONE */

/*
 * If NO_TRANSLATE isn't defined then we need to define
 * the filename translate versions of the file access
 * routines...
 */
#ifndef NO_FTRANSLATE

/* Define the file open + name translation routine */
# ifdef unlink
#  undef unlink
# endif
# ifdef stat
#  undef stat
# endif

#define fopen MY_fopen
#define fread MY_fread
#define fwrite MY_fwrite
#define unlink MY_unlink
#define rmdir MY_rmdir
#define mkdir MY_mkdir
#define rename_file MY_rename


#ifdef WINDOWS
#define stat MY_stat
#endif

TY_int MY_stat (char *path, struct MY_stat *statbuf);
TY_int MY_rename (const char *, const char *);
FILE *MY_fopen (const char *, const char *);
TY_int MY_unlink (const char *);
size_t MY_fread (void *, size_t, size_t, FILE *);
size_t MY_fwrite (void *, size_t, size_t, FILE *);
TY_int MY_rmdir (char *);
TY_int MY_mkdir (char *);
char *filename_translate (const char *in_filename);
#else
#define rename_file Rename
#endif /* ndef NO_FTRANSLATE */
