/*
 * Prototypes for functions defined in
 * re_main.c
 */

extern TY_int RE_allow_scale_y;

#ifdef MOTIF
TY_int RE_init_resource (char *, unsigned, char **);
#else
TY_int RE_init_resource (char *);
#endif

RE_resource *RE_create_resources (ZPL_WINDOW *, char *);

TY_int RE_dispose (RE_resource *);

void RE_add_resources (RE_resource *, MD_WINDOW_P);

TY_int RE_set_scrollbar (RE_resource_entry *, TY_int, TY_int, TY_int);

RE_resource *RE_add_scrollbar (RE_resource *, MD_WINDOW_P, ZPL_WINDOW *);

void RE_delete_resources (RE_resource *, MD_WINDOW_P);

RE_resource *RE_resize_scrollbar (RE_resource *, ZPL_WINDOW *);

void free_resource_entry (RE_resource_entry *);

TY_int RE_free_resource (RE_resource *);

RE_resource_entry *RE_find_resource (char *, RE_resource *);

void RE_set_process (RE_resource_entry *, void (*)(), void *);

TY_int find_gid (RE_resource_entry *);

void RE_add_lv (RE_resource_entry *, void *);

void RE_select_lv (RE_resource_entry *, TY_int);

void RE_set_top_lv (RE_resource_entry *, TY_int);

void RE_scroll_lv (RE_resource_entry *, TY_int);

void RE_page_scroll_lv (RE_resource_entry *, TY_int);

void *RE_detach_lv (RE_resource_entry *);

void *RE_remove_lv (RE_resource_entry *);

void RE_reattach_lv (RE_resource_entry *);

TY_int RE_get_value (RE_resource_entry *);

void RE_set_value (RE_resource_entry *, TY_int);

void RE_update_item (RE_resource_entry *, TY_int);

TY_int RE_process_event (RE_resource_entry *, struct IntuiMessage *);

void RE_set_item (RE_resource *, char *, void *, TY_int);

void RE_update (RE_resource *);

RE_resource_entry *RE_find_is (RE_resource *, TY_int);

RE_resource_entry *RE_find_shortcut (RE_resource *, TY_int);

void RE_set_max (RE_resource_entry *, TY_int);

void RE_process_shortcut (RE_resource_entry *, struct IntuiMessage *, MD_WINDOW_P);

void RE_disable_gadget (RE_resource_entry *);

void RE_enable_gadget (RE_resource_entry *);

TY_int RE_is_valid_gadget (RE_resource *, MD_GADGET_P);

/*
 * Prototypes for functions defined in
 * re_ng.c
 */

extern TY_int x_offset;

extern TY_int y_offset;

extern TY_int FontX;

extern TY_int FontY;

extern TY_int re_debug;

extern TY_int x_offset;

extern TY_int y_offset;

extern TY_int FontX;

extern TY_int FontY;

extern TY_int re_debug;

struct GadgetData *make_gadget_data (MD_NEWGADGET_P, unsigned TY_int);

MD_GADGET_P NG_mx (MD_GADGET_P, RE_new_gadget *, char **, TY_int, TY_int);

MD_GADGET_P NG_cycle (MD_GADGET_P, RE_new_gadget *, char **);

MD_GADGET_P NG_box (MD_GADGET_P, RE_new_gadget *, TY_int, TY_int);

MD_GADGET_P NG_button (MD_GADGET_P, RE_new_gadget *);

MD_GADGET_P NG_numeric (MD_GADGET_P, RE_new_gadget *, TY_int, TY_int);

MD_GADGET_P NG_string (MD_GADGET_P, RE_new_gadget *, TY_int, char *);

struct List *NG_initlv (struct List *);

void NG_freelv (struct List *);

void NG_freelv_and_data (struct List *);

void NG_addlv (struct List *, void *);

TY_int NG_lv_size (struct List *);

void *NG_find_element (struct List *, TY_int);

TY_int NG_find_TY_int (struct List *, TY_int, TY_int (*)());

TY_int NG_find_name (struct List *, char *);

TY_int NG_match_string (struct List *, char *, TY_int, TY_int (*)(), void *);

MD_GADGET_P NG_lv (MD_GADGET_P, RE_new_gadget *, struct List *, TY_int);

MD_GADGET_P NG_sb (MD_GADGET_P, RE_new_gadget *, TY_int, TY_int, TY_int, TY_int);

MD_GADGET_P NG_text (MD_GADGET_P, RE_new_gadget *, TY_int);

MD_GADGET_P NG_slider (MD_GADGET_P, RE_new_gadget *, TY_int, TY_int);

MD_GADGET_P NG_palette (MD_GADGET_P, RE_new_gadget *, TY_int, TY_int);


FILE_LIST *NG_display_text (char *);
FILE_LIST *NG_display_file (FILE *);

FILE_LIST *NG_display_named_file (char *);

void NG_free_file (FILE_LIST *);

RE_resource_entry *RE_locate_resource_id (int, RE_resource *);
TY_int RE_get_named_value (char *, RE_resource * r);
void RE_set_named_value (char *, TY_int, RE_resource *);

void NG_print_list (struct List *, char *);
void NG_list_output (FILE *, struct List *);
void NG_alpha_sort_list (struct List *lis);
void NG_sort_list (struct List *lis, int (*)(const void *, const void *));
void RE_set_all_gadgets (RE_resource *, TY_int);
void RE_make_item (RE_resource * , char *, TY_int );
TY_int NG_find_int (struct List * , TY_int , TY_int (*func) (void *, TY_int));
void NG_save_list (struct List *l, char *);
