/*---------------------------------------------------------------------------
 *
 *      Title:          ZPL - Prototypes
 *
 *      Date:           May 1995
 *
 *      Description:
 *          This module contains prototypes which aren't defined elsewhere (e.g.
 *      RE prototypes are in re_proto.h, and alloc checking are in My_alloc.
 *
 *      Rev     By              Description                            Date
 *      1.0     R.J.Harrison    Implement                              2-5-95
 *
 *      Copyright  1995 Zaretto Ltd.
 *---------------------------------------------------------------------------*/


/* Prototypes for functions defined in
getargs.c
 */
TY_int getargs(TY_int argc,
            unsigned char ** argv,
            ARG * tabp,
            TY_int tabsize);
/* Prototypes for functions defined in
event.c
 */
TY_int check_events(ZPL_WINDOW * );
TY_int dump_events(ZPL_WINDOW * );
TY_int rawkey_convert(struct IntuiMessage * , unsigned char * , TY_int , struct KeyMap * );
void DoKeys(struct IntuiMessage * , ZPL_WINDOW * );
TY_int event(struct IntuiMessage * , ZPL_WINDOW * );
void set_event_keymap (void *);
/* Prototypes for functions defined in
set_syst.c
 */
void set_system_time(time_t );
/* Prototypes for functions defined in
strinp.c
 */
void convert_attr_to_font(struct TextAttr * , TEXT_FONT * );
void convert_font_to_attr(TEXT_FONT * , struct TextAttr * );
void get_colour_tv(void);
void tell_em(unsigned char * , unsigned char * );
void * get_font(unsigned char * , TY_int , void * );
TY_int strinput(ZPL_WINDOW * , unsigned char * , unsigned char * , TY_int );
TY_int passinput(ZPL_WINDOW * , unsigned char * , unsigned char * , TY_int , TY_int );
TY_int numinput(ZPL_WINDOW * , TY_int * , unsigned char * );
TY_int ranged_numinput (ZPL_WINDOW * fw, TY_int *curval, char *title, TY_int minval, TY_int maxval);
void file_error(unsigned char * );
TY_int do_it(unsigned char * , unsigned char * );
TY_int do_it_n(unsigned char * , unsigned char * );
TY_int show_em(unsigned char * );
unsigned char * check_new_file(unsigned char * );
TY_int file_exists(unsigned char * );
TY_int multi_do_it(unsigned char * , unsigned char * , unsigned char * );
TY_int multi_do_it_n(unsigned char * , unsigned char * , unsigned char * );
unsigned char * file_request_path(unsigned char * , unsigned char * );
unsigned char * file_request_path_save(unsigned char * , unsigned char * );
unsigned char * file_request_nopath(unsigned char * , unsigned char * );
unsigned char * file_request(unsigned char * );
char *dir_request (char *prompt, char *working_directory);
/* Prototypes for functions defined in
control.c
 */
void set_interactive_mode(long );
long is_interactive(void);
void fatal_error(unsigned char * );
TY_int init_window(void);
TY_int using_v36(void);
TY_int using_v38(void);
TY_int get_gadtools_version(void);
struct Screen * get_custom_screen(void);
TY_int get_intensity(TY_int );
TY_int brightest_colour(void);
TY_int darkest_colour(void);
TY_int menu_background_not_black(void);
void save_palette(void);
void load_palette(void);
struct Screen * find_workbench_screen(void);
struct Screen * get_screen(void);
short get_screen_width(void);
short get_screen_height(void);
UBYTE get_screen_depth(void);
void set_window_font_changed(void);
void enable_event_checking(void);
void disable_event_checking(void);
TY_int events_enabled(void);
void do_global_action(ACTION , TY_int , TY_int );
void * do_all_windows(void * (* )(ZPL_WINDOW * , void * ), void * );
void add_window_to_list(ZPL_WINDOW * );
void remove_window_from_list(ZPL_WINDOW * );
void lock_window(ZPL_WINDOW * );
void unlock_window(ZPL_WINDOW * );
TY_int window_locked(ZPL_WINDOW * );
void set_close_allow(ZPL_WINDOW * , TY_int );
void close_window(ZPL_WINDOW * );
void FW_close_safely(ZPL_WINDOW * );
void prefs_make_all_default(void);
void send_content_changed(ZPL_WINDOW * );
void send_content_changed_param(ZPL_WINDOW * , TY_int );
ZPL_WINDOW * find_window(struct Window * );
ZPL_WINDOW * find_window_type(TY_int );
TY_int add_console_to_window(ZPL_WINDOW * );
struct TextAttr * get_window_font(void);
struct TextAttr * init_font(struct TextAttr * , struct TextFont ** );
void set_window_font(ZPL_WINDOW * );
ZPL_WINDOW * open_window_at(GENERAL_WINDOW * , TY_int , TY_int , TY_int , TY_int );
ZPL_WINDOW * open_window(GENERAL_WINDOW * );
void FW_close(ZPL_WINDOW * );
void close_all_windows(TY_int );
void close_all_children(void);
void do_child_windows(ZPL_WINDOW * , TY_int (* )(ZPL_WINDOW * , void * ), void * );
void close_system(void);
void update_windows(void);
void check_close_safely(void);
void do_events(void);
void wait_for_event(void);
ULONG get_signal_mask(void);
ULONG just_wait_for_event(void);
void do_received_events(void);
void fake_message(ZPL_WINDOW * );
void global_disable_group(TY_int );
void global_enable_group(TY_int );
void resize_window(struct Window * , TY_int , TY_int );
TY_int get_window_title_height(void);
struct TextFont * get_console_font(void);
TY_int FW_system(unsigned char * );
void quit_window(TY_int , ZPL_WINDOW * );
TY_int get_message_code(struct IntuiMessage * );
unsigned short get_message_key(void * );
unsigned long get_message_class(void * );
struct IntuiMessage * get_blank_message(void);
TY_int get_number_of_windows(void);
void all_windows_busy(TY_int );
/* Prototypes for functions defined in
prefs_db.c
 */
TY_int write_pref(PREFERENCE_ENTRY * , FILE * );
void free_pref(PREFERENCE_ENTRY * );
PREFERENCE_ENTRY * read_pref(FILE * );
PREFERENCES * PR_new_database(unsigned char * );
PREFERENCES * PR_open_database(unsigned char * );
TY_int PR_save_database_as(PREFERENCES * , unsigned char * );
TY_int PR_save_database(PREFERENCES * );
TY_int PR_close_database(PREFERENCES * );
PREFERENCE_ENTRY * PR_get_item(PREFERENCES * , unsigned char * );
void PR_mark_as_changed(PREFERENCES * );
TY_int PR_add_item(PREFERENCES * , unsigned char * , void * , TY_int );
void PR_open(unsigned char * );
void PR_mark_changed(void);
TY_int PR_finish(void);
PREFERENCES * PR_get_prefs(void);
GENERIC_PREF * PR_init_load(TY_int , unsigned char * , void (* )(void * ), unsigned char * );
/* Prototypes for functions defined in
wop.c
 */
TY_int locate_high(unsigned char * );
unsigned char * do_line_highlighting(TY_int , unsigned char * );
void FW_scroll(ZPL_WINDOW * , TY_int );
void FW_scroll_up(ZPL_WINDOW * , TY_int );
void FW_write(ZPL_WINDOW * , UBYTE * , TY_int );
void FW_puts(ZPL_WINDOW * , UBYTE * );
void FW_puts_hl(ZPL_WINDOW * , UBYTE * );
void FW_activate(ZPL_WINDOW * );
void FW_to_front(ZPL_WINDOW * , TY_int );
void FW_to_back(ZPL_WINDOW * , TY_int );
unsigned char FW_getc(ZPL_WINDOW * );
void FW_set_busy_pointer(ZPL_WINDOW * );
void FW_clear_busy_pointer(ZPL_WINDOW * );
void FW_set_title(ZPL_WINDOW * , unsigned char * );
TY_int FW_scale_text_x(ZPL_WINDOW * , TY_int );
TY_int FW_scale_text_y(ZPL_WINDOW * , TY_int );
void FW_line_r(ZPL_WINDOW * , TY_int , TY_int );
void FW_line(ZPL_WINDOW * , TY_int , TY_int , TY_int , TY_int );
void FW_fill_r(ZPL_WINDOW * , TY_int , TY_int , TY_int , TY_int );
void FW_move(ZPL_WINDOW * , TY_int , TY_int );
void FW_move_s(ZPL_WINDOW * , TY_int , TY_int );
void FW_reset_scroll(ZPL_WINDOW * );
void FW_set_scroll(ZPL_WINDOW * );
void FW_erase_textline(ZPL_WINDOW * , TY_int , TY_int );
void FW_erase_to_eol(ZPL_WINDOW * );
void FW_cls(ZPL_WINDOW * );
void FW_colour(ZPL_WINDOW * , TY_int );
void FW_gcolour(ZPL_WINDOW * , TY_int );
void FW_gtext(ZPL_WINDOW * , TY_int , TY_int , unsigned char * );
void FW_prompt(ZPL_WINDOW * );
void FW_erase_prompt(ZPL_WINDOW * );
void FW_set_prompt(ZPL_WINDOW * , unsigned char * );
TY_int FW_do_more(ZPL_WINDOW * , TY_int );
void FW_output_more(ZPL_WINDOW * );
void FW_output_all_text(ZPL_WINDOW * );
void FW_gr_text(ZPL_WINDOW * , TY_int , TY_int , unsigned char * );
void FW_text(ZPL_WINDOW * , TY_int , TY_int , unsigned char * );
TY_int FW_output_disabled(ZPL_WINDOW * );
void FW_clear_more(ZPL_WINDOW * );
void FW_printf(ZPL_WINDOW * , unsigned char * , ...);
void FW_putc(ZPL_WINDOW * , unsigned char , TEXT_COORDINATE , TEXT_COORDINATE );
void FW_remove_cursor(ZPL_WINDOW * );
void FW_draw_cursor(ZPL_WINDOW * , TY_int , TY_int );
void FW_cursor_move(ZPL_WINDOW * );
void error_log(unsigned char * , ...);
void log_message(unsigned char * , ...);
void FW_error(ZPL_WINDOW * , unsigned char * );
TY_int FW_fp_type_file(ZPL_WINDOW * , FILE * );
TY_int FW_type_file(ZPL_WINDOW * , unsigned char * );
TY_int FW_get_size(ZPL_WINDOW * );
void change_window_size(ZPL_WINDOW * );
void FW_iedit(ZPL_WINDOW * );
void FW_redraw_frame(ZPL_WINDOW * );
TY_int FW_get_left_edge(ZPL_WINDOW * );
TY_int FW_get_top_edge(ZPL_WINDOW * );
TY_int FW_get_height(ZPL_WINDOW * );
TY_int FW_get_width(ZPL_WINDOW * );
TY_int FW_get_border_top(ZPL_WINDOW * );
unsigned char * FW_get_title(ZPL_WINDOW * );
void draw_complete_line(ZPL_WINDOW * , TY_int , TY_int , TY_int );
void draw_bevel_box(ZPL_WINDOW * fw, TY_int sx, TY_int sy, TY_int ex, TY_int ey);
void draw_complete_box(ZPL_WINDOW * , TY_int , TY_int , TY_int , TY_int );
void calculate_window_size(TY_int * , TY_int , TY_int * , TY_int );
void FW_init_window(ZPL_WINDOW * );

/* Prototypes for functions defined in
misc.c
 */

unsigned char * skip_spaces(unsigned char * );
TY_int filesize(FILE * );
void write_int(FILE * , TY_int );
void write_text(FILE * , unsigned char * );
TY_int read_int(FILE * );
unsigned char * read_text_ec(FILE * , TY_int * );
unsigned char * read_text(FILE * );
unsigned char * strindex(unsigned char * , unsigned char * );
unsigned char ** getnamelist(unsigned char * );
unsigned char * op_ltoa(TY_int );
unsigned char * decrud(unsigned char * );
void change_case_upper(unsigned char * );
void change_case_lower(unsigned char * );
void nchange_case_upper(unsigned char * , TY_int );
void nchange_case_lower(unsigned char * , TY_int );
void cr_expand(unsigned char * );
unsigned char * file_part(unsigned char * );
unsigned char * directory_part(unsigned char * );
unsigned char * add_part(unsigned char * , unsigned char * , TY_int );
void decr(unsigned char * );
void remove_cr(unsigned char * );
TY_int read_line(unsigned char * , TY_int , FILE * );
unsigned char * str_insert(unsigned char * , TY_int );
void WW_wraptext(unsigned char * , TY_int );
TY_int move_file(unsigned char * , unsigned char * );
TY_int copy_file(unsigned char * , unsigned char * );
TY_int file_present(unsigned char * );
unsigned char * strmxcpy(unsigned char * , unsigned char * , TY_int );
TY_int file_match(unsigned char * , unsigned char * , TY_int );
FILE * create_message_save(unsigned char * , TY_int );
void message_save(FILE * , unsigned char * );
void finish_message_save(FILE * , TY_int );
unsigned char * output_conf_name(unsigned char * , unsigned char * );
TY_int named_filesize(unsigned char * );
TY_int get_file_date(unsigned char * );
TY_int does_file_exist(unsigned char * );
time_t get_file_modtime(unsigned char * );
unsigned char * FIB_get_name(struct FileInfoBlock * );
void treewalk(unsigned char * filename,
              void (* fn)(),
              void * arg);
TY_int walk(unsigned char * filename,
         void (* fn)(),
         unsigned char * path,
         unsigned char * arg);
void gsub(unsigned char * , unsigned char , unsigned char );
unsigned char * make_text_from_open_file(FILE * );
unsigned char * make_text_from_file(unsigned char * );
unsigned char * describe_size(TY_int );
TY_int free_mem_size(void);
unsigned char * strcpy_field(TY_int , unsigned char * , unsigned char * );
unsigned char * make_space(unsigned char * , unsigned char ** , TY_int , TY_int * );
void insert_space(unsigned char * , TY_int );
unsigned char * skip_sp(unsigned char * );
unsigned char * get_short_time(time_t );
void put_file_id(FILE * , TY_int );
TY_int get_file_id(FILE * , unsigned char * );
TY_int check_file_id(FILE * , unsigned char * , TY_int );
FILE *smart_fopen (char *name, char *mode, char *msg);


/* Prototypes for functions defined in keymap.c
 */
struct MY_KeyMap * CreateAppKeyMap(void (* )(struct MY_KeyMap * ));

/*
 * Get the project specific prototypes.
 */
#include "protos.h"
